libgo: Update Go library to master revision 15489/921e53d4863c.
[gcc.git] / libgo / mksysinfo.sh
1 #!/bin/sh
2
3 # Copyright 2009 The Go Authors. All rights reserved.
4 # Use of this source code is governed by a BSD-style
5 # license that can be found in the LICENSE file.
6
7 # Create sysinfo.go.
8
9 # This shell script creates the sysinfo.go file which holds types and
10 # constants extracted from the system header files. This relies on a
11 # hook in gcc: the -fdump-go-spec option will generate debugging
12 # information in Go syntax.
13
14 # We currently #include all the files at once, which works, but leads
15 # to exposing some names which ideally should not be exposed, as they
16 # match grep patterns. E.g., WCHAR_MIN gets exposed because it starts
17 # with W, like the wait flags.
18
19 CC=${CC:-gcc}
20 OUT=tmp-sysinfo.go
21
22 set -e
23
24 rm -f sysinfo.c
25 cat > sysinfo.c <<EOF
26 #include "config.h"
27
28 #include <sys/types.h>
29 #include <dirent.h>
30 #include <errno.h>
31 #include <fcntl.h>
32 #include <netinet/in.h>
33 /* <netinet/tcp.h> needs u_char/u_short, but <sys/bsd_types> is only
34 included by <netinet/in.h> if _SGIAPI (i.e. _SGI_SOURCE
35 && !_XOPEN_SOURCE.
36 <sys/termios.h> only defines TIOCNOTTY if !_XOPEN_SOURCE, while
37 <sys/ttold.h> does so unconditionally. */
38 #ifdef __sgi__
39 #include <sys/bsd_types.h>
40 #include <sys/ttold.h>
41 #endif
42 #include <netinet/tcp.h>
43 #if defined(HAVE_NETINET_IN_SYSTM_H)
44 #include <netinet/in_systm.h>
45 #endif
46 #if defined(HAVE_NETINET_IP_H)
47 #include <netinet/ip.h>
48 #endif
49 #if defined(HAVE_NETINET_IP_MROUTE_H)
50 #include <netinet/ip_mroute.h>
51 #endif
52 #if defined(HAVE_NETINET_IF_ETHER_H)
53 #include <netinet/if_ether.h>
54 #endif
55 #include <signal.h>
56 #include <sys/ioctl.h>
57 #include <termios.h>
58 #if defined(HAVE_SYSCALL_H)
59 #include <syscall.h>
60 #endif
61 #if defined(HAVE_SYS_SYSCALL_H)
62 #include <sys/syscall.h>
63 #endif
64 #if defined(HAVE_SYS_EPOLL_H)
65 #include <sys/epoll.h>
66 #endif
67 #if defined(HAVE_SYS_FILE_H)
68 #include <sys/file.h>
69 #endif
70 #if defined(HAVE_SYS_MMAN_H)
71 #include <sys/mman.h>
72 #endif
73 #if defined(HAVE_SYS_PRCTL_H)
74 #include <sys/prctl.h>
75 #endif
76 #if defined(HAVE_SYS_PTRACE_H)
77 #include <sys/ptrace.h>
78 #endif
79 #include <sys/resource.h>
80 #include <sys/uio.h>
81 #include <sys/socket.h>
82 #include <sys/stat.h>
83 #include <sys/time.h>
84 #include <sys/times.h>
85 #include <sys/wait.h>
86 #include <sys/un.h>
87 #if defined(HAVE_SYS_USER_H)
88 #include <sys/user.h>
89 #endif
90 #if defined(HAVE_SYS_UTSNAME_H)
91 #include <sys/utsname.h>
92 #endif
93 #if defined(HAVE_SYS_SELECT_H)
94 #include <sys/select.h>
95 #endif
96 #include <time.h>
97 #include <unistd.h>
98 #include <netdb.h>
99 #include <pwd.h>
100 #if defined(HAVE_LINUX_FILTER_H)
101 #include <linux/filter.h>
102 #endif
103 #if defined(HAVE_LINUX_IF_ADDR_H)
104 #include <linux/if_addr.h>
105 #endif
106 #if defined(HAVE_LINUX_IF_ETHER_H)
107 #include <linux/if_ether.h>
108 #endif
109 #if defined(HAVE_LINUX_IF_TUN_H)
110 #include <linux/if_tun.h>
111 #endif
112 #if defined(HAVE_LINUX_NETLINK_H)
113 #include <linux/netlink.h>
114 #endif
115 #if defined(HAVE_LINUX_RTNETLINK_H)
116 #include <linux/rtnetlink.h>
117 #endif
118 #if defined(HAVE_NET_IF_H)
119 #include <net/if.h>
120 #endif
121 #if defined(HAVE_NET_IF_ARP_H)
122 #include <net/if_arp.h>
123 #endif
124 #if defined(HAVE_NET_ROUTE_H)
125 #include <net/route.h>
126 #endif
127 #if defined (HAVE_NETPACKET_PACKET_H)
128 #include <netpacket/packet.h>
129 #endif
130 #if defined(HAVE_SYS_MOUNT_H)
131 #include <sys/mount.h>
132 #endif
133 #if defined(HAVE_SYS_VFS_H)
134 #include <sys/vfs.h>
135 #endif
136 #if defined(HAVE_STATFS_H)
137 #include <sys/statfs.h>
138 #endif
139 #if defined(HAVE_SYS_TIMEX_H)
140 #include <sys/timex.h>
141 #endif
142 #if defined(HAVE_SYS_SYSINFO_H)
143 #include <sys/sysinfo.h>
144 #endif
145 #if defined(HAVE_USTAT_H)
146 #include <ustat.h>
147 #endif
148 #if defined(HAVE_UTIME_H)
149 #include <utime.h>
150 #endif
151 #if defined(HAVE_LINUX_ETHER_H)
152 #include <linux/ether.h>
153 #endif
154 #if defined(HAVE_LINUX_FS_H)
155 #include <linux/fs.h>
156 #endif
157 #if defined(HAVE_LINUX_REBOOT_H)
158 #include <linux/reboot.h>
159 #endif
160 #if defined(HAVE_SYS_INOTIFY_H)
161 #include <sys/inotify.h>
162 #endif
163
164 /* Constants that may only be defined as expressions on some systems,
165 expressions too complex for -fdump-go-spec to handle. These are
166 handled specially below. */
167 enum {
168 #ifdef TIOCGWINSZ
169 TIOCGWINSZ_val = TIOCGWINSZ,
170 #endif
171 #ifdef TIOCNOTTY
172 TIOCNOTTY_val = TIOCNOTTY,
173 #endif
174 #ifdef TIOCSCTTY
175 TIOCSCTTY_val = TIOCSCTTY,
176 #endif
177 };
178 EOF
179
180 ${CC} -fdump-go-spec=gen-sysinfo.go -std=gnu99 -S -o sysinfo.s sysinfo.c
181
182 echo 'package syscall' > ${OUT}
183 echo 'import "unsafe"' >> ${OUT}
184 echo 'type _ unsafe.Pointer' >> ${OUT}
185
186 # Get all the consts and types, skipping ones which could not be
187 # represented in Go and ones which we need to rewrite. We also skip
188 # function declarations, as we don't need them here. All the symbols
189 # will all have a leading underscore.
190 grep -v '^// ' gen-sysinfo.go | \
191 grep -v '^func' | \
192 grep -v '^type _timeval ' | \
193 grep -v '^type _timespec_t ' | \
194 grep -v '^type _timespec ' | \
195 grep -v '^type _timestruc_t ' | \
196 grep -v '^type _epoll_' | \
197 grep -v 'in6_addr' | \
198 grep -v 'sockaddr_in6' | \
199 sed -e 's/\([^a-zA-Z0-9_]\)_timeval\([^a-zA-Z0-9_]\)/\1Timeval\2/g' \
200 -e 's/\([^a-zA-Z0-9_]\)_timespec_t\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
201 -e 's/\([^a-zA-Z0-9_]\)_timespec\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
202 -e 's/\([^a-zA-Z0-9_]\)_timestruc_t\([^a-zA-Z0-9_]\)/\1Timestruc\2/g' \
203 >> ${OUT}
204
205 # The errno constants. These get type Errno.
206 echo '#include <errno.h>' | ${CC} -x c - -E -dM | \
207 egrep '#define E[A-Z0-9_]+ ' | \
208 sed -e 's/^#define \(E[A-Z0-9_]*\) .*$/const \1 = Errno(_\1)/' >> ${OUT}
209
210 # The O_xxx flags.
211 egrep '^const _(O|F|FD)_' gen-sysinfo.go | \
212 sed -e 's/^\(const \)_\([^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
213 if ! grep '^const O_ASYNC' ${OUT} >/dev/null 2>&1; then
214 echo "const O_ASYNC = 0" >> ${OUT}
215 fi
216 if ! grep '^const O_CLOEXEC' ${OUT} >/dev/null 2>&1; then
217 echo "const O_CLOEXEC = 0" >> ${OUT}
218 fi
219
220 # These flags can be lost on i386 GNU/Linux when using
221 # -D_FILE_OFFSET_BITS=64, because we see "#define F_SETLK F_SETLK64"
222 # before we see the definition of F_SETLK64.
223 for flag in F_GETLK F_SETLK F_SETLKW; do
224 if ! grep "^const ${flag} " ${OUT} >/dev/null 2>&1 \
225 && grep "^const ${flag}64 " ${OUT} >/dev/null 2>&1; then
226 echo "const ${flag} = ${flag}64" >> ${OUT}
227 fi
228 done
229
230 # The signal numbers.
231 grep '^const _SIG[^_]' gen-sysinfo.go | \
232 grep -v '^const _SIGEV_' | \
233 sed -e 's/^\(const \)_\(SIG[^= ]*\)\(.*\)$/\1\2 = Signal(_\2)/' >> ${OUT}
234 if ! grep '^const SIGPOLL ' ${OUT} >/dev/null 2>&1; then
235 if grep '^const SIGIO ' ${OUT} > /dev/null 2>&1; then
236 echo "const SIGPOLL = SIGIO" >> ${OUT}
237 fi
238 fi
239 if ! grep '^const SIGCLD ' ${OUT} >/dev/null 2>&1; then
240 if grep '^const SIGCHLD ' ${OUT} >/dev/null 2>&1; then
241 echo "const SIGCLD = SIGCHLD" >> ${OUT}
242 fi
243 fi
244
245 # The syscall numbers. We force the names to upper case.
246 grep '^const _SYS_' gen-sysinfo.go | \
247 sed -e 's/const _\(SYS_[^= ]*\).*$/\1/' | \
248 while read sys; do
249 sup=`echo $sys | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
250 echo "const $sup = _$sys" >> ${OUT}
251 done
252
253 # The GNU/Linux support wants to use SYS_GETDENTS64 if available.
254 if ! grep '^const SYS_GETDENTS ' ${OUT} >/dev/null 2>&1; then
255 echo "const SYS_GETDENTS = 0" >> ${OUT}
256 fi
257 if ! grep '^const SYS_GETDENTS64 ' ${OUT} >/dev/null 2>&1; then
258 echo "const SYS_GETDENTS64 = 0" >> ${OUT}
259 fi
260
261 # Stat constants.
262 grep '^const _S_' gen-sysinfo.go | \
263 sed -e 's/^\(const \)_\(S_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
264
265 # Mmap constants.
266 grep '^const _PROT_' gen-sysinfo.go | \
267 sed -e 's/^\(const \)_\(PROT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
268 grep '^const _MAP_' gen-sysinfo.go | \
269 sed -e 's/^\(const \)_\(MAP_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
270 grep '^const _MADV_' gen-sysinfo.go | \
271 sed -e 's/^\(const \)_\(MADV_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
272 grep '^const _MCL_' gen-sysinfo.go | \
273 sed -e 's/^\(const \)_\(MCL_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
274
275 # Process status constants.
276 grep '^const _W' gen-sysinfo.go |
277 sed -e 's/^\(const \)_\(W[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
278 # WSTOPPED was introduced in glibc 2.3.4.
279 if ! grep '^const _WSTOPPED = ' gen-sysinfo.go >/dev/null 2>&1; then
280 if grep '^const _WUNTRACED = ' gen-sysinfo.go > /dev/null 2>&1; then
281 echo 'const WSTOPPED = _WUNTRACED' >> ${OUT}
282 else
283 echo 'const WSTOPPED = 2' >> ${OUT}
284 fi
285 fi
286 if grep '^const ___WALL = ' gen-sysinfo.go >/dev/null 2>&1 \
287 && ! grep '^const _WALL = ' gen-sysinfo.go >/dev/null 2>&1; then
288 echo 'const WALL = ___WALL' >> ${OUT}
289 fi
290
291 # Networking constants.
292 egrep '^const _(AF|ARPHRD|ETH|IN|SOCK|SOL|SO|IPPROTO|TCP|IP|IPV6)_' gen-sysinfo.go |
293 sed -e 's/^\(const \)_\([^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
294 grep '^const _SOMAXCONN' gen-sysinfo.go |
295 sed -e 's/^\(const \)_\(SOMAXCONN[^= ]*\)\(.*\)$/\1\2 = _\2/' \
296 >> ${OUT}
297 grep '^const _SHUT_' gen-sysinfo.go |
298 sed -e 's/^\(const \)_\(SHUT[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
299
300 # The net package requires some const definitions.
301 for m in IP_PKTINFO IPV6_V6ONLY IPPROTO_IPV6 IPV6_JOIN_GROUP IPV6_LEAVE_GROUP IPV6_TCLASS SO_REUSEPORT; do
302 if ! grep "^const $m " ${OUT} >/dev/null 2>&1; then
303 echo "const $m = 0" >> ${OUT}
304 fi
305 done
306 for m in SOCK_CLOEXEC SOCK_NONBLOCK; do
307 if ! grep "^const $m " ${OUT} >/dev/null 2>&1; then
308 echo "const $m = -1" >> ${OUT}
309 fi
310 done
311
312 # pathconf constants.
313 grep '^const __PC' gen-sysinfo.go |
314 sed -e 's/^\(const \)__\(PC[^= ]*\)\(.*\)$/\1\2 = __\2/' >> ${OUT}
315
316 # The PATH_MAX constant.
317 if grep '^const _PATH_MAX ' gen-sysinfo.go >/dev/null 2>&1; then
318 echo 'const PathMax = _PATH_MAX' >> ${OUT}
319 fi
320
321 # epoll constants.
322 grep '^const _EPOLL' gen-sysinfo.go |
323 sed -e 's/^\(const \)_\(EPOLL[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
324 # Make sure EPOLLRDHUP and EPOLL_CLOEXEC are defined.
325 if ! grep '^const EPOLLRDHUP' ${OUT} >/dev/null 2>&1; then
326 echo "const EPOLLRDHUP = 0x2000" >> ${OUT}
327 fi
328 if ! grep '^const EPOLL_CLOEXEC' ${OUT} >/dev/null 2>&1; then
329 echo "const EPOLL_CLOEXEC = 02000000" >> ${OUT}
330 fi
331
332 # Prctl constants.
333 grep '^const _PR_' gen-sysinfo.go |
334 sed -e 's/^\(const \)_\(PR_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
335
336 # Ptrace constants.
337 grep '^const _PTRACE' gen-sysinfo.go |
338 sed -e 's/^\(const \)_\(PTRACE[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
339 # We need some ptrace options that are not defined in older versions
340 # of glibc.
341 if ! grep '^const PTRACE_SETOPTIONS' ${OUT} > /dev/null 2>&1; then
342 echo "const PTRACE_SETOPTIONS = 0x4200" >> ${OUT}
343 fi
344 if ! grep '^const PTRACE_O_TRACESYSGOOD' ${OUT} > /dev/null 2>&1; then
345 echo "const PTRACE_O_TRACESYSGOOD = 0x1" >> ${OUT}
346 fi
347 if ! grep '^const PTRACE_O_TRACEFORK' ${OUT} > /dev/null 2>&1; then
348 echo "const PTRACE_O_TRACEFORK = 0x2" >> ${OUT}
349 fi
350 if ! grep '^const PTRACE_O_TRACEVFORK' ${OUT} > /dev/null 2>&1; then
351 echo "const PTRACE_O_TRACEVFORK = 0x4" >> ${OUT}
352 fi
353 if ! grep '^const PTRACE_O_TRACECLONE' ${OUT} > /dev/null 2>&1; then
354 echo "const PTRACE_O_TRACECLONE = 0x8" >> ${OUT}
355 fi
356 if ! grep '^const PTRACE_O_TRACEEXEC' ${OUT} > /dev/null 2>&1; then
357 echo "const PTRACE_O_TRACEEXEC = 0x10" >> ${OUT}
358 fi
359 if ! grep '^const PTRACE_O_TRACEVFORKDONE' ${OUT} > /dev/null 2>&1; then
360 echo "const PTRACE_O_TRACEVFORKDONE = 0x20" >> ${OUT}
361 fi
362 if ! grep '^const PTRACE_O_TRACEEXIT' ${OUT} > /dev/null 2>&1; then
363 echo "const PTRACE_O_TRACEEXIT = 0x40" >> ${OUT}
364 fi
365 if ! grep '^const PTRACE_O_MASK' ${OUT} > /dev/null 2>&1; then
366 echo "const PTRACE_O_MASK = 0x7f" >> ${OUT}
367 fi
368 if ! grep '^const _PTRACE_GETEVENTMSG' ${OUT} > /dev/null 2>&1; then
369 echo "const PTRACE_GETEVENTMSG = 0x4201" >> ${OUT}
370 fi
371 if ! grep '^const PTRACE_EVENT_FORK' ${OUT} > /dev/null 2>&1; then
372 echo "const PTRACE_EVENT_FORK = 1" >> ${OUT}
373 fi
374 if ! grep '^const PTRACE_EVENT_VFORK' ${OUT} > /dev/null 2>&1; then
375 echo "const PTRACE_EVENT_VFORK = 2" >> ${OUT}
376 fi
377 if ! grep '^const PTRACE_EVENT_CLONE' ${OUT} > /dev/null 2>&1; then
378 echo "const PTRACE_EVENT_CLONE = 3" >> ${OUT}
379 fi
380 if ! grep '^const PTRACE_EVENT_EXEC' ${OUT} > /dev/null 2>&1; then
381 echo "const PTRACE_EVENT_EXEC = 4" >> ${OUT}
382 fi
383 if ! grep '^const PTRACE_EVENT_VFORK_DONE' ${OUT} > /dev/null 2>&1; then
384 echo "const PTRACE_EVENT_VFORK_DONE = 5" >> ${OUT}
385 fi
386 if ! grep '^const PTRACE_EVENT_EXIT' ${OUT} > /dev/null 2>&1; then
387 echo "const PTRACE_EVENT_EXIT = 6" >> ${OUT}
388 fi
389 if ! grep '^const _PTRACE_TRACEME' ${OUT} > /dev/null 2>&1; then
390 echo "const _PTRACE_TRACEME = 0" >> ${OUT}
391 fi
392
393 # The registers returned by PTRACE_GETREGS. This is probably
394 # GNU/Linux specific; it should do no harm if there is no
395 # _user_regs_struct.
396 regs=`grep '^type _user_regs_struct struct' gen-sysinfo.go || true`
397 if test "$regs" != ""; then
398 regs=`echo $regs | sed -e 's/type _user_regs_struct struct //' -e 's/[{}]//g'`
399 regs=`echo $regs | sed -e s'/^ *//'`
400 nregs=
401 while test -n "$regs"; do
402 field=`echo $regs | sed -e 's/^\([^;]*\);.*$/\1/'`
403 regs=`echo $regs | sed -e 's/^[^;]*; *\(.*\)$/\1/'`
404 # Capitalize the first character of the field.
405 f=`echo $field | sed -e 's/^\(.\).*$/\1/'`
406 r=`echo $field | sed -e 's/^.\(.*\)$/\1/'`
407 f=`echo $f | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
408 field="$f$r"
409 nregs="$nregs $field;"
410 done
411 echo "type PtraceRegs struct {$nregs }" >> ${OUT}
412 fi
413
414 # Some basic types.
415 echo 'type Size_t _size_t' >> ${OUT}
416 echo "type Ssize_t _ssize_t" >> ${OUT}
417 if grep '^const _HAVE_OFF64_T = ' gen-sysinfo.go > /dev/null 2>&1; then
418 echo "type Offset_t _off64_t" >> ${OUT}
419 else
420 echo "type Offset_t _off_t" >> ${OUT}
421 fi
422 echo "type Mode_t _mode_t" >> ${OUT}
423 echo "type Pid_t _pid_t" >> ${OUT}
424 echo "type Uid_t _uid_t" >> ${OUT}
425 echo "type Gid_t _gid_t" >> ${OUT}
426 echo "type Socklen_t _socklen_t" >> ${OUT}
427
428 # The C int type.
429 sizeof_int=`grep '^const ___SIZEOF_INT__ = ' gen-sysinfo.go | sed -e 's/.*= //'`
430 if test "$sizeof_int" = "4"; then
431 echo "type _C_int int32" >> ${OUT}
432 elif test "$sizeof_int" = "8"; then
433 echo "type _C_int int64" >> ${OUT}
434 else
435 echo 1>&2 "mksysinfo.sh: could not determine size of int (got $sizeof_int)"
436 exit 1
437 fi
438
439 # The C long type, needed because that is the type that ptrace returns.
440 sizeof_long=`grep '^const ___SIZEOF_LONG__ = ' gen-sysinfo.go | sed -e 's/.*= //'`
441 if test "$sizeof_long" = "4"; then
442 echo "type _C_long int32" >> ${OUT}
443 elif test "$sizeof_long" = "8"; then
444 echo "type _C_long int64" >> ${OUT}
445 else
446 echo 1>&2 "mksysinfo.sh: could not determine size of long (got $sizeof_long)"
447 exit 1
448 fi
449
450 # Solaris 2 needs _u?pad128_t, but its default definition in terms of long
451 # double is commented by -fdump-go-spec.
452 if grep "^// type _pad128_t" gen-sysinfo.go > /dev/null 2>&1; then
453 echo "type _pad128_t struct { _l [4]int32; }" >> ${OUT}
454 fi
455 if grep "^// type _upad128_t" gen-sysinfo.go > /dev/null 2>&1; then
456 echo "type _upad128_t struct { _l [4]uint32; }" >> ${OUT}
457 fi
458
459 # The time_t type.
460 if grep '^type _time_t ' gen-sysinfo.go > /dev/null 2>&1; then
461 echo 'type Time_t _time_t' >> ${OUT}
462 fi
463
464 # The time structures need special handling: we need to name the
465 # types, so that we can cast integers to the right types when
466 # assigning to the structures.
467 timeval=`grep '^type _timeval ' gen-sysinfo.go`
468 timeval_sec=`echo $timeval | sed -n -e 's/^.*tv_sec \([^ ]*\);.*$/\1/p'`
469 timeval_usec=`echo $timeval | sed -n -e 's/^.*tv_usec \([^ ]*\);.*$/\1/p'`
470 echo "type Timeval_sec_t $timeval_sec" >> ${OUT}
471 echo "type Timeval_usec_t $timeval_usec" >> ${OUT}
472 echo $timeval | \
473 sed -e 's/type _timeval /type Timeval /' \
474 -e 's/tv_sec *[a-zA-Z0-9_]*/Sec Timeval_sec_t/' \
475 -e 's/tv_usec *[a-zA-Z0-9_]*/Usec Timeval_usec_t/' >> ${OUT}
476 timespec=`grep '^type _timespec ' gen-sysinfo.go || true`
477 if test "$timespec" = ""; then
478 # IRIX 6.5 has __timespec instead.
479 timespec=`grep '^type ___timespec ' gen-sysinfo.go || true`
480 fi
481 timespec_sec=`echo $timespec | sed -n -e 's/^.*tv_sec \([^ ]*\);.*$/\1/p'`
482 timespec_nsec=`echo $timespec | sed -n -e 's/^.*tv_nsec \([^ ]*\);.*$/\1/p'`
483 echo "type Timespec_sec_t $timespec_sec" >> ${OUT}
484 echo "type Timespec_nsec_t $timespec_nsec" >> ${OUT}
485 echo $timespec | \
486 sed -e 's/^type ___timespec /type Timespec /' \
487 -e 's/^type _timespec /type Timespec /' \
488 -e 's/tv_sec *[a-zA-Z0-9_]*/Sec Timespec_sec_t/' \
489 -e 's/tv_nsec *[a-zA-Z0-9_]*/Nsec Timespec_nsec_t/' >> ${OUT}
490
491 timestruc=`grep '^type _timestruc_t ' gen-sysinfo.go || true`
492 if test "$timestruc" != ""; then
493 timestruc_sec=`echo $timestruc | sed -n -e 's/^.*tv_sec \([^ ]*\);.*$/\1/p'`
494 timestruc_nsec=`echo $timestruc | sed -n -e 's/^.*tv_nsec \([^ ]*\);.*$/\1/p'`
495 echo "type Timestruc_sec_t $timestruc_sec" >> ${OUT}
496 echo "type Timestruc_nsec_t $timestruc_nsec" >> ${OUT}
497 echo $timestruc | \
498 sed -e 's/^type _timestruc_t /type Timestruc /' \
499 -e 's/tv_sec *[a-zA-Z0-9_]*/Sec Timestruc_sec_t/' \
500 -e 's/tv_nsec *[a-zA-Z0-9_]*/Nsec Timestruc_nsec_t/' >> ${OUT}
501 fi
502
503 # The tms struct.
504 grep '^type _tms ' gen-sysinfo.go | \
505 sed -e 's/type _tms/type Tms/' \
506 -e 's/tms_utime/Utime/' \
507 -e 's/tms_stime/Stime/' \
508 -e 's/tms_cutime/Cutime/' \
509 -e 's/tms_cstime/Cstime/' \
510 >> ${OUT}
511
512 # The stat type.
513 # Prefer largefile variant if available.
514 stat=`grep '^type _stat64 ' gen-sysinfo.go || true`
515 if test "$stat" != ""; then
516 grep '^type _stat64 ' gen-sysinfo.go
517 else
518 grep '^type _stat ' gen-sysinfo.go
519 fi | sed -e 's/type _stat64/type Stat_t/' \
520 -e 's/type _stat/type Stat_t/' \
521 -e 's/st_dev/Dev/' \
522 -e 's/st_ino/Ino/g' \
523 -e 's/st_nlink/Nlink/' \
524 -e 's/st_mode/Mode/' \
525 -e 's/st_uid/Uid/' \
526 -e 's/st_gid/Gid/' \
527 -e 's/st_rdev/Rdev/' \
528 -e 's/st_size/Size/' \
529 -e 's/st_blksize/Blksize/' \
530 -e 's/st_blocks/Blocks/' \
531 -e 's/st_atim/Atim/' \
532 -e 's/st_mtim/Mtim/' \
533 -e 's/st_ctim/Ctim/' \
534 -e 's/\([^a-zA-Z0-9_]\)_timeval\([^a-zA-Z0-9_]\)/\1Timeval\2/g' \
535 -e 's/\([^a-zA-Z0-9_]\)_timespec_t\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
536 -e 's/\([^a-zA-Z0-9_]\)_timespec\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
537 -e 's/\([^a-zA-Z0-9_]\)_timestruc_t\([^a-zA-Z0-9_]\)/\1Timestruc\2/g' \
538 -e 's/Godump_[0-9] struct { \([^;]*;\) };/\1/g' \
539 >> ${OUT}
540
541 # The directory searching types.
542 # Prefer largefile variant if available.
543 dirent=`grep '^type _dirent64 ' gen-sysinfo.go || true`
544 if test "$dirent" != ""; then
545 grep '^type _dirent64 ' gen-sysinfo.go
546 else
547 grep '^type _dirent ' gen-sysinfo.go
548 fi | sed -e 's/type _dirent64/type Dirent/' \
549 -e 's/type _dirent/type Dirent/' \
550 -e 's/d_name \[0+1\]/d_name [0+256]/' \
551 -e 's/d_name/Name/' \
552 -e 's/]int8/]byte/' \
553 -e 's/d_ino/Ino/' \
554 -e 's/d_off/Off/' \
555 -e 's/d_reclen/Reclen/' \
556 -e 's/d_type/Type/' \
557 >> ${OUT}
558 echo "type DIR _DIR" >> ${OUT}
559
560 # Values for d_type field in dirent.
561 grep '^const _DT_' gen-sysinfo.go |
562 sed -e 's/^\(const \)_\(DT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
563
564 # The rusage struct.
565 rusage=`grep '^type _rusage struct' gen-sysinfo.go`
566 if test "$rusage" != ""; then
567 # Remove anonymous unions from GNU/Linux <bits/resource.h>.
568 rusage=`echo $rusage | sed -e 's/Godump_[0-9]* struct {\([^}]*\)};/\1/g'`
569 rusage=`echo $rusage | sed -e 's/type _rusage struct //' -e 's/[{}]//g'`
570 rusage=`echo $rusage | sed -e 's/^ *//'`
571 nrusage=
572 while test -n "$rusage"; do
573 field=`echo $rusage | sed -e 's/^\([^;]*\);.*$/\1/'`
574 rusage=`echo $rusage | sed -e 's/^[^;]*; *\(.*\)$/\1/'`
575 # Drop the leading ru_, capitalize the next character.
576 field=`echo $field | sed -e 's/^ru_//'`
577 f=`echo $field | sed -e 's/^\(.\).*$/\1/'`
578 r=`echo $field | sed -e 's/^.\(.*\)$/\1/'`
579 f=`echo $f | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
580 # Fix _timeval _timespec, and _timestruc_t.
581 r=`echo $r | sed -e s'/ _timeval$/ Timeval/'`
582 r=`echo $r | sed -e s'/ _timespec$/ Timespec/'`
583 r=`echo $r | sed -e s'/ _timestruc_t$/ Timestruc/'`
584 field="$f$r"
585 nrusage="$nrusage $field;"
586 done
587 echo "type Rusage struct {$nrusage }" >> ${OUT}
588 else
589 echo "type Rusage struct {}" >> ${OUT}
590 fi
591
592 # The RUSAGE constants.
593 grep '^const _RUSAGE_' gen-sysinfo.go | \
594 sed -e 's/^\(const \)_\(RUSAGE_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
595
596 # The utsname struct.
597 grep '^type _utsname ' gen-sysinfo.go | \
598 sed -e 's/_utsname/Utsname/' \
599 -e 's/sysname/Sysname/' \
600 -e 's/nodename/Nodename/' \
601 -e 's/release/Release/' \
602 -e 's/version/Version/' \
603 -e 's/machine/Machine/' \
604 -e 's/domainname/Domainname/' \
605 >> ${OUT}
606
607 # The iovec struct.
608 iovec=`grep '^type _iovec ' gen-sysinfo.go`
609 iovec_len=`echo $iovec | sed -n -e 's/^.*iov_len \([^ ]*\);.*$/\1/p'`
610 echo "type Iovec_len_t $iovec_len" >> ${OUT}
611 echo $iovec | \
612 sed -e 's/_iovec/Iovec/' \
613 -e 's/iov_base/Base/' \
614 -e 's/iov_len *[a-zA-Z0-9_]*/Len Iovec_len_t/' \
615 >> ${OUT}
616
617 # The msghdr struct.
618 msghdr=`grep '^type _msghdr ' gen-sysinfo.go`
619 msghdr_controllen=`echo $msghdr | sed -n -e 's/^.*msg_controllen \([^ ]*\);.*$/\1/p'`
620 echo "type Msghdr_controllen_t $msghdr_controllen" >> ${OUT}
621 echo $msghdr | \
622 sed -e 's/_msghdr/Msghdr/' \
623 -e 's/msg_name/Name/' \
624 -e 's/msg_namelen/Namelen/' \
625 -e 's/msg_iov/Iov/' \
626 -e 's/msg_iovlen/Iovlen/' \
627 -e 's/_iovec/Iovec/' \
628 -e 's/msg_control/Control/' \
629 -e 's/msg_controllen *[a-zA-Z0-9_]*/Controllen Msghdr_controllen_t/' \
630 -e 's/msg_flags/Flags/' \
631 >> ${OUT}
632
633 # The MSG_ flags for Msghdr.
634 grep '^const _MSG_' gen-sysinfo.go | \
635 sed -e 's/^\(const \)_\(MSG_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
636
637 # The cmsghdr struct.
638 cmsghdr=`grep '^type _cmsghdr ' gen-sysinfo.go`
639 if test -n "$cmsghdr"; then
640 cmsghdr_len=`echo $cmsghdr | sed -n -e 's/^.*cmsg_len \([^ ]*\);.*$/\1/p'`
641 echo "type Cmsghdr_len_t $cmsghdr_len" >> ${OUT}
642 echo "$cmsghdr" | \
643 sed -e 's/_cmsghdr/Cmsghdr/' \
644 -e 's/cmsg_len *[a-zA-Z0-9_]*/Len Cmsghdr_len_t/' \
645 -e 's/cmsg_level/Level/' \
646 -e 's/cmsg_type/Type/' \
647 -e 's/\[\]/[0]/' \
648 >> ${OUT}
649 fi
650
651 # The SCM_ flags for Cmsghdr.
652 grep '^const _SCM_' gen-sysinfo.go | \
653 sed -e 's/^\(const \)_\(SCM_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
654
655 # The ucred struct.
656 grep '^type _ucred ' gen-sysinfo.go | \
657 sed -e 's/_ucred/Ucred/' \
658 -e 's/pid/Pid/' \
659 -e 's/uid/Uid/' \
660 -e 's/gid/Gid/' \
661 >> ${OUT}
662
663 # The ip_mreq struct.
664 grep '^type _ip_mreq ' gen-sysinfo.go | \
665 sed -e 's/_ip_mreq/IPMreq/' \
666 -e 's/imr_multiaddr/Multiaddr/' \
667 -e 's/imr_interface/Interface/' \
668 -e 's/_in_addr/[4]byte/g' \
669 >> ${OUT}
670
671 # We need IPMreq to compile the net package.
672 if ! grep 'type IPMreq ' ${OUT} >/dev/null 2>&1; then
673 echo 'type IPMreq struct { Multiaddr [4]byte; Interface [4]byte; }' >> ${OUT}
674 fi
675
676 # The ipv6_mreq struct.
677 grep '^type _ipv6_mreq ' gen-sysinfo.go | \
678 sed -e 's/_ipv6_mreq/IPv6Mreq/' \
679 -e 's/ipv6mr_multiaddr/Multiaddr/' \
680 -e 's/ipv6mr_interface/Interface/' \
681 -e 's/_in6_addr/[16]byte/' \
682 >> ${OUT}
683
684 # We need IPv6Mreq to compile the net package.
685 if ! grep 'type IPv6Mreq ' ${OUT} >/dev/null 2>&1; then
686 echo 'type IPv6Mreq struct { Multiaddr [16]byte; Interface uint32; }' >> ${OUT}
687 fi
688
689 # The ip_mreqn struct.
690 grep '^type _ip_mreqn ' gen-sysinfo.go | \
691 sed -e 's/_ip_mreqn/IPMreqn/' \
692 -e 's/imr_multiaddr/Multiaddr/' \
693 -e 's/imr_address/Address/' \
694 -e 's/imr_ifindex/Ifindex/' \
695 -e 's/_in_addr/[4]byte/g' \
696 >> ${OUT}
697
698 # We need IPMreq to compile the net package.
699 if ! grep 'type IPMreqn ' ${OUT} >/dev/null 2>&1; then
700 echo 'type IPMreqn struct { Multiaddr [4]byte; Interface [4]byte; Ifindex int32 }' >> ${OUT}
701 fi
702
703 # Try to guess the type to use for fd_set.
704 fd_set=`grep '^type _fd_set ' gen-sysinfo.go || true`
705 fds_bits_type="_C_long"
706 if test "$fd_set" != ""; then
707 fds_bits_type=`echo $fd_set | sed -e 's/.*[]]\([^;]*\); }$/\1/'`
708 fi
709 echo "type fds_bits_type $fds_bits_type" >> ${OUT}
710
711 # The addrinfo struct.
712 grep '^type _addrinfo ' gen-sysinfo.go | \
713 sed -e 's/_addrinfo/Addrinfo/g' \
714 -e 's/ ai_/ Ai_/g' \
715 >> ${OUT}
716
717 # The addrinfo flags and errors.
718 grep '^const _AI_' gen-sysinfo.go | \
719 sed -e 's/^\(const \)_\(AI_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
720 grep '^const _EAI_' gen-sysinfo.go | \
721 sed -e 's/^\(const \)_\(EAI_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
722
723 # The passwd struct.
724 grep '^type _passwd ' gen-sysinfo.go | \
725 sed -e 's/_passwd/Passwd/' \
726 -e 's/ pw_/ Pw_/g' \
727 >> ${OUT}
728
729 # The ioctl flags for the controlling TTY.
730 grep '^const _TIOC' gen-sysinfo.go | \
731 grep -v '_val =' | \
732 sed -e 's/^\(const \)_\(TIOC[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
733 # We need TIOCGWINSZ.
734 if ! grep '^const TIOCGWINSZ' ${OUT} >/dev/null 2>&1; then
735 if grep '^const _TIOCGWINSZ_val' ${OUT} >/dev/null 2>&1; then
736 echo 'const TIOCGWINSZ = _TIOCGWINSZ_val' >> ${OUT}
737 fi
738 fi
739 if ! grep '^const TIOCNOTTY' ${OUT} >/dev/null 2>&1; then
740 if grep '^const _TIOCNOTTY_val' ${OUT} >/dev/null 2>&1; then
741 echo 'const TIOCNOTTY = _TIOCNOTTY_val' >> ${OUT}
742 fi
743 fi
744 if ! grep '^const TIOCSCTTY' ${OUT} >/dev/null 2>&1; then
745 if grep '^const _TIOCSCTTY_val' ${OUT} >/dev/null 2>&1; then
746 echo 'const TIOCSCTTY = _TIOCSCTTY_val' >> ${OUT}
747 fi
748 fi
749
750 # The ioctl flags for terminal control
751 grep '^const _TC[GS]ET' gen-sysinfo.go | \
752 sed -e 's/^\(const \)_\(TC[GS]ET[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
753
754 # ioctl constants. Might fall back to 0 if TIOCNXCL is missing, too, but
755 # needs handling in syscalls.exec.go.
756 if ! grep '^const _TIOCSCTTY ' gen-sysinfo.go >/dev/null 2>&1; then
757 if grep '^const _TIOCNXCL ' gen-sysinfo.go >/dev/null 2>&1; then
758 echo "const TIOCSCTTY = TIOCNXCL" >> ${OUT}
759 fi
760 fi
761
762 # The nlmsghdr struct.
763 grep '^type _nlmsghdr ' gen-sysinfo.go | \
764 sed -e 's/_nlmsghdr/NlMsghdr/' \
765 -e 's/nlmsg_len/Len/' \
766 -e 's/nlmsg_type/Type/' \
767 -e 's/nlmsg_flags/Flags/' \
768 -e 's/nlmsg_seq/Seq/' \
769 -e 's/nlmsg_pid/Pid/' \
770 >> ${OUT}
771
772 # The nlmsg flags and operators.
773 grep '^const _NLM' gen-sysinfo.go | \
774 sed -e 's/^\(const \)_\(NLM[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
775
776 # NLMSG_HDRLEN is defined as an expression using sizeof.
777 if ! grep '^const NLMSG_HDRLEN' ${OUT} > /dev/null 2>&1; then
778 if grep '^const _sizeof_nlmsghdr ' ${OUT} > /dev/null 2>&1; then
779 echo 'const NLMSG_HDRLEN = (_sizeof_nlmsghdr + (NLMSG_ALIGNTO-1)) &^ (NLMSG_ALIGNTO-1)' >> ${OUT}
780 fi
781 fi
782
783 # The rtmsg struct.
784 grep '^type _rtmsg ' gen-sysinfo.go | \
785 sed -e 's/_rtmsg/RtMsg/' \
786 -e 's/rtm_family/Family/' \
787 -e 's/rtm_dst_len/Dst_len/' \
788 -e 's/rtm_src_len/Src_len/' \
789 -e 's/rtm_tos/Tos/' \
790 -e 's/rtm_table/Table/' \
791 -e 's/rtm_protocol/Protocol/' \
792 -e 's/rtm_scope/Scope/' \
793 -e 's/rtm_type/Type/' \
794 -e 's/rtm_flags/Flags/' \
795 >> ${OUT}
796
797 # The rtgenmsg struct.
798 grep '^type _rtgenmsg ' gen-sysinfo.go | \
799 sed -e 's/_rtgenmsg/RtGenmsg/' \
800 -e 's/rtgen_family/Family/' \
801 >> ${OUT}
802
803 # The routing message flags.
804 grep '^const _RT_' gen-sysinfo.go | \
805 sed -e 's/^\(const \)_\(RT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
806 grep '^const _RTA' gen-sysinfo.go | \
807 sed -e 's/^\(const \)_\(RTA[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
808 grep '^const _RTF' gen-sysinfo.go | \
809 sed -e 's/^\(const \)_\(RTF[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
810 grep '^const _RTCF' gen-sysinfo.go | \
811 sed -e 's/^\(const \)_\(RTCF[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
812 grep '^const _RTM' gen-sysinfo.go | \
813 sed -e 's/^\(const \)_\(RTM[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
814 grep '^const _RTN' gen-sysinfo.go | \
815 sed -e 's/^\(const \)_\(RTN[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
816 grep '^const _RTPROT' gen-sysinfo.go | \
817 sed -e 's/^\(const \)_\(RTPROT[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
818
819 # The ifinfomsg struct.
820 grep '^type _ifinfomsg ' gen-sysinfo.go | \
821 sed -e 's/_ifinfomsg/IfInfomsg/' \
822 -e 's/ifi_family/Family/' \
823 -e 's/ifi_type/Type/' \
824 -e 's/ifi_index/Index/' \
825 -e 's/ifi_flags/Flags/' \
826 -e 's/ifi_change/Change/' \
827 >> ${OUT}
828
829 # The interface information types and flags.
830 grep '^const _IFA' gen-sysinfo.go | \
831 sed -e 's/^\(const \)_\(IFA[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
832 grep '^const _IFLA' gen-sysinfo.go | \
833 sed -e 's/^\(const \)_\(IFLA[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
834 grep '^const _IFF' gen-sysinfo.go | \
835 sed -e 's/^\(const \)_\(IFF[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
836 grep '^const _IFNAMSIZ' gen-sysinfo.go | \
837 sed -e 's/^\(const \)_\(IFNAMSIZ[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
838 grep '^const _SIOC' gen-sysinfo.go |
839 sed -e 's/^\(const \)_\(SIOC[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
840
841 # The ifaddrmsg struct.
842 grep '^type _ifaddrmsg ' gen-sysinfo.go | \
843 sed -e 's/_ifaddrmsg/IfAddrmsg/' \
844 -e 's/ifa_family/Family/' \
845 -e 's/ifa_prefixlen/Prefixlen/' \
846 -e 's/ifa_flags/Flags/' \
847 -e 's/ifa_scope/Scope/' \
848 -e 's/ifa_index/Index/' \
849 >> ${OUT}
850
851 # The rtattr struct.
852 grep '^type _rtattr ' gen-sysinfo.go | \
853 sed -e 's/_rtattr/RtAttr/' \
854 -e 's/rta_len/Len/' \
855 -e 's/rta_type/Type/' \
856 >> ${OUT}
857
858 # The in_pktinfo struct.
859 grep '^type _in_pktinfo ' gen-sysinfo.go | \
860 sed -e 's/_in_pktinfo/Inet4Pktinfo/' \
861 -e 's/ipi_ifindex/Ifindex/' \
862 -e 's/ipi_spec_dst/Spec_dst/' \
863 -e 's/ipi_addr/Addr/' \
864 -e 's/_in_addr/[4]byte/g' \
865 >> ${OUT}
866
867 # The in6_pktinfo struct.
868 grep '^type _in6_pktinfo ' gen-sysinfo.go | \
869 sed -e 's/_in6_pktinfo/Inet6Pktinfo/' \
870 -e 's/ipi6_addr/Addr/' \
871 -e 's/ipi6_ifindex/Ifindex/' \
872 -e 's/_in6_addr/[16]byte/' \
873 >> ${OUT}
874
875 # The termios struct.
876 grep '^type _termios ' gen-sysinfo.go | \
877 sed -e 's/_termios/Termios/' \
878 -e 's/c_iflag/Iflag/' \
879 -e 's/c_oflag/Oflag/' \
880 -e 's/c_cflag/Cflag/' \
881 -e 's/c_lflag/Lflag/' \
882 -e 's/c_line/Line/' \
883 -e 's/c_cc/Cc/' \
884 -e 's/c_ispeed/Ispeed/' \
885 -e 's/c_ospeed/Ospeed/' \
886 >> ${OUT}
887
888 # The termios constants.
889 for n in IGNBRK BRKINT IGNPAR PARMRK INPCK ISTRIP INLCR IGNCR ICRNL IUCLC \
890 IXON IXANY IXOFF IMAXBEL IUTF8 OPOST OLCUC ONLCR OCRNL ONOCR ONLRET \
891 OFILL OFDEL NLDLY NL0 NL1 CRDLY CR0 CR1 CR2 CR3 CS5 CS6 CS7 CS8 TABDLY \
892 BSDLY VTDLY FFDLY CBAUD CBAUDEX CSIZE CSTOPB CREAD PARENB PARODD HUPCL \
893 CLOCAL LOBLK CIBAUD CMSPAR CRTSCTS ISIG ICANON XCASE ECHO ECHOE ECHOK \
894 ECHONL ECHOCTL ECHOPRT ECHOKE DEFECHO FLUSHO NOFLSH TOSTOP PENDIN IEXTEN \
895 VINTR VQUIT VERASE VKILL VEOF VMIN VEOL VTIME VEOL2 VSWTCH VSTART VSTOP \
896 VSUSP VDSUSP VLNEXT VWERASE VREPRINT VDISCARD VSTATUS TCSANOW TCSADRAIN \
897 TCSAFLUSH TCIFLUSH TCOFLUSH TCIOFLUSH TCOOFF TCOON TCIOFF TCION B0 B50 \
898 B75 B110 B134 B150 B200 B300 B600 B1200 B1800 B2400 B4800 B9600 B19200 \
899 B38400 B57600 B115200 B230400 B460800 B500000 B576000 B921600 B1000000 \
900 B1152000 B1500000 B2000000 B2500000 B3000000 B3500000 B4000000; do
901
902 grep "^const _$n " gen-sysinfo.go | \
903 sed -e 's/^\(const \)_\([^=]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
904 done
905
906 # The mount flags
907 grep '^const _MNT_' gen-sysinfo.go |
908 sed -e 's/^\(const \)_\(MNT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
909 grep '^const _MS_' gen-sysinfo.go |
910 sed -e 's/^\(const \)_\(MS_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
911
912 # The fallocate flags.
913 grep '^const _FALLOC_' gen-sysinfo.go |
914 sed -e 's/^\(const \)_\(FALLOC_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
915
916 # The statfs struct.
917 # Prefer largefile variant if available.
918 statfs=`grep '^type _statfs64 ' gen-sysinfo.go || true`
919 if test "$statfs" != ""; then
920 grep '^type _statfs64 ' gen-sysinfo.go
921 else
922 grep '^type _statfs ' gen-sysinfo.go
923 fi | sed -e 's/type _statfs64/type Statfs_t/' \
924 -e 's/type _statfs/type Statfs_t/' \
925 -e 's/f_type/Type/' \
926 -e 's/f_bsize/Bsize/' \
927 -e 's/f_blocks/Blocks/' \
928 -e 's/f_bfree/Bfree/' \
929 -e 's/f_bavail/Bavail/' \
930 -e 's/f_files/Files/' \
931 -e 's/f_ffree/Ffree/' \
932 -e 's/f_fsid/Fsid/' \
933 -e 's/f_namelen/Namelen/' \
934 -e 's/f_frsize/Frsize/' \
935 -e 's/f_flags/Flags/' \
936 -e 's/f_spare/Spare/' \
937 >> ${OUT}
938
939 # The timex struct.
940 timex=`grep '^type _timex ' gen-sysinfo.go || true`
941 if test "$timex" = ""; then
942 timex=`grep '^// type _timex ' gen-sysinfo.go || true`
943 if test "$timex" != ""; then
944 timex=`echo $timex | sed -e 's|// ||' -e 's/INVALID-bit-field/int32/g'`
945 fi
946 fi
947 if test "$timex" != ""; then
948 echo "$timex" | \
949 sed -e 's/_timex/Timex/' \
950 -e 's/modes/Modes/' \
951 -e 's/offset/Offset/' \
952 -e 's/freq/Freq/' \
953 -e 's/maxerror/Maxerror/' \
954 -e 's/esterror/Esterror/' \
955 -e 's/status/Status/' \
956 -e 's/constant/Constant/' \
957 -e 's/precision/Precision/' \
958 -e 's/tolerance/Tolerance/' \
959 -e 's/ time / Time /' \
960 -e 's/tick/Tick/' \
961 -e 's/ppsfreq/Ppsfreq/' \
962 -e 's/jitter/Jitter/' \
963 -e 's/shift/Shift/' \
964 -e 's/stabil/Stabil/' \
965 -e 's/jitcnt/Jitcnt/' \
966 -e 's/calcnt/Calcnt/' \
967 -e 's/errcnt/Errcnt/' \
968 -e 's/stbcnt/Stbcnt/' \
969 -e 's/tai/Tai/' \
970 -e 's/_timeval/Timeval/' \
971 >> ${OUT}
972 fi
973
974 # The rlimit struct.
975 grep '^type _rlimit ' gen-sysinfo.go | \
976 sed -e 's/_rlimit/Rlimit/' \
977 -e 's/rlim_cur/Cur/' \
978 -e 's/rlim_max/Max/' \
979 >> ${OUT}
980
981 # The RLIMIT constants.
982 grep '^const _RLIMIT_' gen-sysinfo.go |
983 sed -e 's/^\(const \)_\(RLIMIT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
984 grep '^const _RLIM_' gen-sysinfo.go |
985 sed -e 's/^\(const \)_\(RLIM_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
986
987 # The sysinfo struct.
988 grep '^type _sysinfo ' gen-sysinfo.go | \
989 sed -e 's/_sysinfo/Sysinfo_t/' \
990 -e 's/uptime/Uptime/' \
991 -e 's/loads/Loads/' \
992 -e 's/totalram/Totalram/' \
993 -e 's/freeram/Freeram/' \
994 -e 's/sharedram/Sharedram/' \
995 -e 's/bufferram/Bufferram/' \
996 -e 's/totalswap/Totalswap/' \
997 -e 's/freeswap/Freeswap/' \
998 -e 's/procs/Procs/' \
999 -e 's/totalhigh/Totalhigh/' \
1000 -e 's/freehigh/Freehigh/' \
1001 -e 's/mem_unit/Unit/' \
1002 >> ${OUT}
1003
1004 # The ustat struct.
1005 grep '^type _ustat ' gen-sysinfo.go | \
1006 sed -e 's/_ustat/Ustat_t/' \
1007 -e 's/f_tfree/Tfree/' \
1008 -e 's/f_tinode/Tinoe/' \
1009 -e 's/f_fname/Fname/' \
1010 -e 's/f_fpack/Fpack/' \
1011 >> ${OUT}
1012 # Force it to be defined, as on some older GNU/Linux systems the
1013 # header file fails when using with <linux/filter.h>.
1014 if ! grep 'type _ustat ' gen-sysinfo.go >/dev/null 2>&1; then
1015 echo 'type Ustat_t struct { Tfree int32; Tinoe uint64; Fname [5+1]int8; Fpack [5+1]int8; }' >> ${OUT}
1016 fi
1017
1018 # The utimbuf struct.
1019 grep '^type _utimbuf ' gen-sysinfo.go | \
1020 sed -e 's/_utimbuf/Utimbuf/' \
1021 -e 's/actime/Actime/' \
1022 -e 's/modtime/Modtime/' \
1023 >> ${OUT}
1024
1025 # The LOCK flags for flock.
1026 grep '^const _LOCK_' gen-sysinfo.go |
1027 sed -e 's/^\(const \)_\(LOCK_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1028
1029 # The GNU/Linux LINUX_REBOOT flags.
1030 grep '^const _LINUX_REBOOT_' gen-sysinfo.go |
1031 sed -e 's/^\(const \)_\(LINUX_REBOOT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1032
1033 # The GNU/Linux sock_filter struct.
1034 grep '^type _sock_filter ' gen-sysinfo.go | \
1035 sed -e 's/_sock_filter/SockFilter/' \
1036 -e 's/code/Code/' \
1037 -e 's/jt/Jt/' \
1038 -e 's/jf/Jf/' \
1039 -e 's/k /K /' \
1040 >> ${OUT}
1041
1042 # The GNU/Linux sock_fprog struct.
1043 grep '^type _sock_fprog ' gen-sysinfo.go | \
1044 sed -e 's/_sock_fprog/SockFprog/' \
1045 -e 's/len/Len/' \
1046 -e 's/filter/Filter/' \
1047 -e 's/_sock_filter/SockFilter/' \
1048 >> ${OUT}
1049
1050 # The GNU/Linux filter flags.
1051 grep '^const _BPF_' gen-sysinfo.go | \
1052 sed -e 's/^\(const \)_\(BPF_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1053
1054 # The GNU/Linux nlattr struct.
1055 grep '^type _nlattr ' gen-sysinfo.go | \
1056 sed -e 's/_nlattr/NlAttr/' \
1057 -e 's/nla_len/Len/' \
1058 -e 's/nla_type/Type/' \
1059 >> ${OUT}
1060
1061 # The GNU/Linux nlmsgerr struct.
1062 grep '^type _nlmsgerr ' gen-sysinfo.go | \
1063 sed -e 's/_nlmsgerr/NlMsgerr/' \
1064 -e 's/error/Error/' \
1065 -e 's/msg/Msg/' \
1066 -e 's/_nlmsghdr/NlMsghdr/' \
1067 >> ${OUT}
1068
1069 # The GNU/Linux rtnexthop struct.
1070 grep '^type _rtnexthop ' gen-sysinfo.go | \
1071 sed -e 's/_rtnexthop/RtNexthop/' \
1072 -e 's/rtnh_len/Len/' \
1073 -e 's/rtnh_flags/Flags/' \
1074 -e 's/rtnh_hops/Hops/' \
1075 -e 's/rtnh_ifindex/Ifindex/' \
1076 >> ${OUT}
1077
1078 # The GNU/Linux netlink flags.
1079 grep '^const _NETLINK_' gen-sysinfo.go | \
1080 sed -e 's/^\(const \)_\(NETLINK_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1081 grep '^const _NLA_' gen-sysinfo.go | \
1082 sed -e 's/^\(const \)_\(NLA_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1083
1084 # The GNU/Linux packet socket flags.
1085 grep '^const _PACKET_' gen-sysinfo.go | \
1086 sed -e 's/^\(const \)_\(PACKET_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1087
1088 # The GNU/Linux inotify_event struct.
1089 grep '^type _inotify_event ' gen-sysinfo.go | \
1090 sed -e 's/_inotify_event/InotifyEvent/' \
1091 -e 's/wd/Wd/' \
1092 -e 's/mask/Mask/' \
1093 -e 's/cookie/Cookie/' \
1094 -e 's/len/Len/' \
1095 -e 's/name/Name/' \
1096 -e 's/\[\]/[0]/' \
1097 -e 's/\[0\]byte/[0]int8/' \
1098 >> ${OUT}
1099
1100 # The Solaris 11 Update 1 _zone_net_addr_t struct.
1101 grep '^type _zone_net_addr_t ' gen-sysinfo.go | \
1102 sed -e 's/_in6_addr/[16]byte/' \
1103 >> ${OUT}
1104
1105 # Struct sizes.
1106 set cmsghdr Cmsghdr ip_mreq IPMreq ip_mreqn IPMreqn ipv6_mreq IPv6Mreq \
1107 ifaddrmsg IfAddrmsg ifinfomsg IfInfomsg in_pktinfo Inet4Pktinfo \
1108 in6_pktinfo Inet6Pktinfo inotify_event InotifyEvent linger Linger \
1109 msghdr Msghdr nlattr NlAttr nlmsgerr NlMsgerr nlmsghdr NlMsghdr \
1110 rtattr RtAttr rtgenmsg RtGenmsg rtmsg RtMsg rtnexthop RtNexthop \
1111 sock_filter SockFilter sock_fprog SockFprog ucred Ucred
1112 while test $# != 0; do
1113 nc=$1
1114 ngo=$2
1115 shift
1116 shift
1117 if grep "^const _sizeof_$nc =" gen-sysinfo.go >/dev/null 2>&1; then
1118 echo "const Sizeof$ngo = _sizeof_$nc" >> ${OUT}
1119 fi
1120 done
1121
1122 # In order to compile the net package, we need some sizes to exist
1123 # even if the types do not.
1124 if ! grep 'const SizeofIPMreq ' ${OUT} >/dev/null 2>&1; then
1125 echo 'const SizeofIPMreq = 8' >> ${OUT}
1126 fi
1127 if ! grep 'const SizeofIPv6Mreq ' ${OUT} >/dev/null 2>&1; then
1128 echo 'const SizeofIPv6Mreq = 20' >> ${OUT}
1129 fi
1130 if ! grep 'const SizeofIPMreqn ' ${OUT} >/dev/null 2>&1; then
1131 echo 'const SizeofIPMreqn = 12' >> ${OUT}
1132 fi
1133
1134 exit $?